#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <cmath>
#include <string>
#include <bits/stdc++.h>
#include <strstream>
#include <queue>

#define USE_MATH_DEFINES

using namespace std;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long int n, q, i, j, b;
    cin>>n>>q;
    long long int* a= new long long int [n+2];
    long long int* l= new long long int [q+2];
    long long int* r= new long long int [q+2];
    for (i=1; i<=n; i++) {
        cin>>a[i];
    }
    for (i=1; i<=q; i++) {
        cin>>l[i]>>r[i];
    }
    for (i=1; i<=q; i++) {
        b=a[l[i]];
        for (j=l[i]+1; j<=r[i]; j++) {
            b=b&a[j];
        }
        cout<<b;
        if (i!=q) {
            cout<<"\n";
        }
    }
    delete[]a;
    return 0;
}